#pragma once

#include <mpv/client.h>
#include <lektor/common.h>
#include <lektor/queue.h>
#include <lektor/reg.h>
#include <sqlite3.h>

void lmpv_free(mpv_handle **ctx);
mpv_handle *lmpv_new(unsigned long int wid, volatile sqlite3 *db);
int lmpv_observe_properties(mpv_handle *ctx);
mpv_handle *lmpv_prepare(volatile sqlite3 *db);

int lmpv_set_volume(mpv_handle *ctx, int vol);
int lmpv_set_position(mpv_handle *ctx, int pos);
int lmpv_load_file(mpv_handle *ctx, const char *file);
int lmpv_toggle_pause(mpv_handle *ctx);

/* TODO: place all pointers inside a struct */
int lmpv_handle(struct lkt_module *mod, mpv_handle *ctx, struct queue *queue,
                volatile int *time_pos, volatile int *time_duration,
                volatile int *state, volatile int *hinib, volatile int *set_seek);

enum {
    STATE_STOP  = 0,
    STATE_PLAY  = 1,
    STATE_PAUSE = 2,
};

#define SET_STATE_FLAG(sta, STATUS) \
    (LOG_DEBUG("WINDOW", "Set status flag to " #STATUS), (sta) = STATE_##STATUS)
